// CopyRight (c) Lefteris Moussiades

#include <iostream>
#include <fstream.h>

template <class T> class stack {
 private: struct item {
           T data;
           item* previous;
          }* top;
  stack<T> reverse() const;
 public:
  stack() {top=0;}
  stack(const stack& source);
  stack(char* fName);
  ~stack();
  bool empty() const {return top==0;}
  void push(T data) {
   item* newItem=new item;
   newItem->previous=top;
   newItem->data=data;
   top=newItem;
  }
  T pop() {
   item* local=top->previous;
   T localData=top->data;
   delete top;
   top=local;
   return localData;
  }
  void save(char* fName);
}; //template class stack


template <class T> void stack<T>::save(char* fName) {
   stack<T> local=reverse();
   ofstream out(fName,ios::binary+ios::out);
   while (!local.empty())
    out.write(reinterpret_cast<char*>(&local.pop()),sizeof(T));
   out.close();
  }

template <class T> stack<T>::stack(char* fName) {
  top=0;
  ifstream  in(fName,ios::binary+ios::in);
  T local;
  do {
   in.read(reinterpret_cast<char*>(&local),sizeof(T));
   if (in.eof()) break;
   else push(local);
  } while (true);
 in.close();
} 


template <class T> stack<T> stack<T>::reverse() const {
 stack<T> local;
 item* cSourcePointer=top;
 while (cSourcePointer!=0) {
  local.push(cSourcePointer->data);
  cSourcePointer=cSourcePointer->previous;
 }
 return local;
}

template <class T> stack<T>::stack(const stack& source) {
 top=0;
 stack<T> local;
 item* cSourcePointer=source.top;
 while (cSourcePointer!=0) {
  local.push(cSourcePointer->data);
  cSourcePointer=cSourcePointer->previous;
 }
 while (!local.empty()) push(local.pop());
}

template <class T> stack<T>::~stack() { while (!empty()) pop(); }

class tstObj {
 static int AA;
 int id;
 public:
  tstObj(int) {id=AA++;}
  tstObj(){}
  int get() const {return id;}
  friend ostream& operator<<(ostream& oS, const tstObj& obj);
};

int tstObj::AA=0;

ostream& operator<<(ostream& oS, const tstObj& obj) {
 return oS << obj.id;
}



main() {

 stack<tstObj> objStack;
 for (int i=0; i<10; i++)
   objStack.push(tstObj(0));
 //while (!objStack.empty()) cout << objStack.pop() << " ";
 objStack.save("objStack.bin");

 cout << endl;

 stack<tstObj>   objStack1("objStack.bin");
 objStack1.push(tstObj(0));
 while (!objStack1.empty()) cout << objStack1.pop() << " ";


 int z;
 cin >> z;
}
